function plotssp2D( envfil )
% plotssp.m
% Plots the sound speed profile

if ( strcmp( envfil, 'ENVFIL' ) == 0 )
    sspfil = [ envfil '.ssp' ];
    envfil = [ envfil '.env' ]; % append extension
end

% set labels in m or km
xlab     = 'Range (m)';
% if ( max( rt ) >= 10000 )
%    rt      = rt / 1000.0;
%    xlab    = 'Range (km)';
% end

[ pltitle, freq, SSP, Bdry, fid ] = readenv( envfil ); % read in the environmental file

%hh = plot( real( SSP.c ), SSP.z );

%%

% Read the SSPFIL

% open the file
fid = fopen( sspfil, 'r' );
if ( fid == -1 )
    warndlg( 'No SSPFIL file with that name exists', 'Warning' );
end

% read
NProf      = fscanf( fid, '%i', 1 );
NSSP = length( SSP.z );
rProf = fscanf( fid, '%f', NProf );
cmat   = fscanf( fid, '%f', [ NProf, NSSP ] )
cmat = cmat';

fclose( fid );
% %%
% 
% %imagesc( rProf, SSP.z, cmat );   % imagesc produces a better PostScript file, using PostScript fonts
% pcolor( rProf, SSP.z, cmat );  ...
% shading interp; colormap( jet );
% colorbar
% set( gca, 'YDir', 'Reverse' )   % because view messes up the zoom feature
% xlabel( xlab ); ylabel( 'Depth (m)' );
% title( deblank( pltitle ) )
% 
% xlabel( 'Range (m)' )
% ylabel( 'Depth (m)' )


for iprof = 1 : NProf
    subplot( 1, NProf, iprof )
    hh = plot( cmat( :, iprof ), SSP.z );
    set( gca, 'YDir', 'Reverse' )   % because view messes up the zoom feature
%axis IJ

if ( iprof == 1 )
xlabel( 'Sound Speed (m/s)' )
ylabel( 'Depth (m)' )
end

set( hh, 'LineWidth', 2 );
axis( [ 1490 1540 0 5000 ] )

if ( iprof > 1 )
    set(gca,'xtick',[],'ytick',[])
end

end



