function write_fieldflp( Pos )

% Writes an environmental file

flpfil = 'field.flp';

fid = fopen( flpfil, 'w' );


fprintf( fid, '/ ! Title \r\n' );
fprintf( fid, '''RA'' ! Option \r\n' );
fprintf( fid, '999999   ! Mlimit (number of modes to include) \r\n' );
fprintf( fid, '1   ! NProf \r\n' );
fprintf( fid, '0.0 /  ! rProf (km) \r\n' );

% receiver ranges
    fprintf( fid, '%5i \t \t ! NRR', length( Pos.r.range ) );
    fprintf( fid, '\r\n    %6.2f  ', Pos.r.range );
    fprintf( fid, '/ \t \t ! RR(1)  ... (m) \r\n' );

% source depths
    fprintf( fid, '%5i \t \t ! NSD', length( Pos.s.depth ) );
    fprintf( fid, '\r\n    %6.2f  ', Pos.s.depth );
    fprintf( fid, '/ \t \t ! SD(1)  ... (m) \r\n' );

% receiver depths
    fprintf( fid, '%5i \t \t ! NRD', length( Pos.r.depth ) );
    fprintf( fid, '\r\n    %6.2f  ', Pos.r.depth );
    fprintf( fid, '/ \t \t ! RD(1)  ... (m) \r\n' );

% receiver range offsets
    fprintf( fid, '%5i \t \t ! NRR', length( Pos.r.depth ) );
    fprintf( fid, '\r\n    %6.2f  ', zeros( size( Pos.r.depth ) ) );
    fprintf( fid, '/ \t \t ! RR(1)  ... (m) \r\n' );

fclose( fid );

