function bellhop( filename )

% run the BELLHOP program

% usage: bellhop( filename )
% where filename is the environmental file
%
% mbp Dec. 2002


if ( isempty( filename ) )
   warndlg( 'No envfil has been selected', 'Warning' );
else
   warning off
   try copyfile( [ filename '.ati' ], 'ATIFIL' ); catch end
   try copyfile( [ filename '.bty' ], 'BTYFIL' ); catch end
   try copyfile( [ filename '.trc' ], 'TRCFIL' ); catch end
   try copyfile( [ filename '.brc' ], 'BRCFIL' ); catch end
   try copyfile( [ filename '.sbp' ], 'SBPFIL' ); catch end
   try copyfile( [ filename '.ssp' ], 'SSPFIL' ); catch end
   
   eval( [ '! bellhop.exe < ' filename '.env > ' filename '.prt' ] )
   
   delete 'ATIFIL';
   delete 'BTYFIL';
   delete 'TRCFIL';
   delete 'BRCFIL';
   delete 'SBPFIL';
   delete 'SSPFIL';
   try movefile( 'ARRFIL', [ filename '.arr' ] ); catch end
   try movefile( 'RAYFIL', [ filename '.ray' ] ); catch end
   try movefile( 'SHDFIL', [ filename '.shd' ] ); catch end
   warning on
end
