function varargout = BottomChar_v3(varargin)
% BOTTOMCHAR_V3 M-file for BottomChar_v3.fig
%      BOTTOMCHAR_V3, by itself, creates a new BOTTOMCHAR_V3 or raises the existing
%      singleton*.
%
%      H = BOTTOMCHAR_V3 returns the handle to a new BOTTOMCHAR_V3 or the handle to
%      the existing singleton*.
%
%      BOTTOMCHAR_V3('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in BOTTOMCHAR_V3.M with the given input arguments.
%
%      BOTTOMCHAR_V3('Property','Value',...) creates a new BOTTOMCHAR_V3 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before BottomChar_v3_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to BottomChar_v3_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help BottomChar_v3

% Last Modified by GUIDE v2.5 13-Feb-2009 16:32:20

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @BottomChar_v3_OpeningFcn, ...
    'gui_OutputFcn',  @BottomChar_v3_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before BottomChar_v3 is made visible.
function BottomChar_v3_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to BottomChar_v3 (see VARARGIN)
SetAxis;
% Choose default command line output for BottomChar_v3
handles.output = hObject;
handles.phi = 4;
handles.type = 11;
handles.ss = 1500;
handles.sd = 1.2;

%Initialize Text Boxes
set(handles.TextIn_GrainSize,'String',handles.phi)
set(handles.TextIn_SedSS,'String',handles.ss);
set(handles.TextIn_SedDens,'String',handles.sd);

% %Initialize Slider Values
set(handles.GS_Slider,'Value',handles.phi );
set(handles.SedSS_Slider,'Value',handles.ss);
set(handles.SedDens_Slider,'Value',handles.sd );
set(handles.SedType,'Value',handles.type);

% Update handles structure
guidata(hObject, handles);
hObject
handles
% UIWAIT makes BottomChar_v3 wait for user response (see UIRESUME)
% uiwait(handles.figure1);

function calculation(hObject,handles)

handles.t = handles.R^2/(5*handles.r^2)*sqrt(2*handles.h/9.81);
guidata(hObject, handles);

switch get(handles.popupmenu2,'Value')
    case 1
        handles.tim = round(1000*handles.t)/1000;
    case 2
        handles.tim = round(1000*handles.t/60)/1000;
    case 3
        handles.tim = round(1000*handles.t/3600)/1000;
end

set(handles.Time,'String',handles.tim)
guidata(hObject, handles);

r = [1:0.1:100];
t = handles.R^2./(5*r.^2).*sqrt(2*handles.h/9.81);

plot(r,tim)
axis([0 100 0 100])
title('The Figure of Time Vs. Hole Radius')


function SetAxis
% axes(handles.axes2);
title('Bottom Loss Curve','FontWeight','demi','FontSize',14)
axis([0 90 0 50])
xlabel('Grazing Angle (degrees)','FontWeight','demi','FontSize',12)
ylabel('Reflection Loss(dB)','FontWeight','demi','FontSize',12)

% --- Outputs from this function are returned to the command line.
function varargout = BottomChar_v3_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in GetProperties.
function GetProperties_Callback(hObject, eventdata, handles)
% hObject    handle to GetProperties (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if(get(handles.RB_GrainSize,'Value') == 1)

    GS = str2num(get(handles.TextIn_GrainSize,'String'));

    %     if (indx == 1)
    %         warndlg('Select Grain Size from pull-down menu.','!! Warning !!')
    %     else
    [SedType,IND]  = Phi2SedType(GS);
    [vr,rhor,rhob,rhow,delta,Refl,Refl_dB,theta,ssbot,Cw] = Mz2GAP(GS);
    set(handles.TextIn_SedSS,'String',ssbot);
    set(handles.SedType,'Value',IND+1);
    set(handles.TextIn_SedDens,'String',rhob);
    plot(theta,Refl_dB)
    SetAxis;
    %     end
elseif(get(handles.RB_SedType,'Value') == 1)
    grsize = [-1:.5:8 9];
    indx = get(handles.SedType,'Value');
    if (indx == 1)
        warndlg('Select Grain Size from pull-down menu.','!! Warning !!')
    else
        GS = grsize(indx-1);

        [vr,rhor,rhob,rhow,delta,Refl,Refl_dB,theta,ssbot,Cw] = Mz2GAP(GS);
        [SedType,IND]  = Phi2SedType(GS);

        set(handles.TextIn_SedSS,'String',ssbot);
        set(handles.TextIn_SedDens,'String',rhob);
        set(handles.TextIn_GrainSize,'String',GS);
        plot(theta,Refl_dB)
        SetAxis;
    end
elseif(get(handles.RB_SedSS,'Value') == 1)

    Cb = str2num(get(handles.TextIn_SedSS,'String'));
    GS = Cb2Mz(Cb);

    [SedType,IND]  = Phi2SedType(GS);
    [vr,rhor,rhob,rhow,delta,Refl,Refl_dB,theta,ssbot,Cw] = Mz2GAP(GS);

    set(handles.SedType,'Value',IND+1);
    set(handles.TextIn_SedDens,'String',rhob);
    set(handles.TextIn_GrainSize,'String',GS);

    plot(theta,Refl_dB)
    SetAxis;
elseif(get(handles.RB_SedDens,'Value') == 1)

    Rhob = str2num(get(handles.TextIn_SedDens,'String'));
    GS = SedDens2Mz(Rhob)
    SedType = Phi2SedType(GS);
    [vr,rhor,rhob,rhow,delta,Refl,Refl_dB,theta,ssbot,Cw] = Mz2GAP(GS);

    set(handles.SedType,'Value',IND+1);
    set(handles.TextIn_SedSS,'String',ssbot);
    set(handles.TextIn_GrainSize,'String',GS);

    plot(theta,Refl_dB)
    SetAxis;
end


function TextIn_SedDens_Callback(hObject, eventdata, handles)
% hObject    handle to TextIn_SedDens (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of TextIn_SedDens as text
%        str2double(get(hObject,'String')) returns contents of TextIn_SedDens as a double


% --- Executes during object creation, after setting all properties.
function TextIn_SedDens_CreateFcn(hObject, eventdata, handles)
% hObject    handle to TextIn_SedDens (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function TextIn_SedSS_Callback(hObject, eventdata, handles)
% hObject    handle to TextIn_SedSS (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of TextIn_SedSS as text
%        str2double(get(hObject,'String')) returns contents of TextIn_SedSS as a double


% --- Executes during object creation, after setting all properties.
function TextIn_SedSS_CreateFcn(hObject, eventdata, handles)
% hObject    handle to TextIn_SedSS (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in SedType.
function SedType_Callback(hObject, eventdata, handles)
% hObject    handle to SedType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns SedType contents as cell array
%        contents{get(hObject,'Value')} returns selected item from SedType


% --- Executes during object creation, after setting all properties.
function SedType_CreateFcn(hObject, eventdata, handles)
% hObject    handle to SedType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function TextIn_GrainSize_Callback(hObject, eventdata, handles)
% hObject    handle to TextIn_GrainSize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of TextIn_GrainSize as text
%        str2double(get(hObject,'String')) returns contents of TextIn_GrainSize as a double


% --- Executes during object creation, after setting all properties.
function TextIn_GrainSize_CreateFcn(hObject, eventdata, handles)
% hObject    handle to TextIn_GrainSize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function SedSS_Slider_Callback(hObject, eventdata, handles)
% hObject    handle to SedSS_Slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function SedSS_Slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to SedSS_Slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function GS_Slider_Callback(hObject, eventdata, handles)
% hObject    handle to GS_Slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
handles.phi = round(100*get(handles.GS_Slider,'Value'))/100;
set(handles.TextIn_GrainSize,'String',handles.phi);

% --- Executes during object creation, after setting all properties.
function GS_Slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to GS_Slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function SedDens_Slider_Callback(hObject, eventdata, handles)
% hObject    handle to SedDens_Slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function SedDens_Slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to SedDens_Slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on mouse motion over figure - except title and menu.
function figure1_WindowButtonMotionFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% [handles] =figure1_WindowButtonDownFcn(hObject, eventdata, handles);
% obj = figure1_WindowButtonDownFcn(hObject, eventdata, handles)
global obj
handles.stat = 1;
obj = get(handles.figure1,'CurrentObject');
% obj = gco(Tank3)
% obj = gco
% obj = gcbo
% obj = handles.obj;
if ~isempty(obj)
    if (obj == handles.GS_Slider);
        handles.phi = round(100*get(handles.GS_Slider,'Value'))/100;
        set(handles.TextIn_GrainSize,'String',handles.phi);
        GS = str2num(get(handles.TextIn_GrainSize,'String'));

        %     if (indx == 1)
        %         warndlg('Select Grain Size from pull-down menu.','!! Warning !!')
        %     else
        [SedType,IND]  = Phi2SedType(GS);
        [vr,rhor,rhob,rhow,delta,Refl,Refl_dB,theta,ssbot,Cw] = Mz2GAP(GS);

        set(handles.TextIn_SedSS,'String',ssbot);
        set(handles.SedType,'Value',IND+1);
        set(handles.TextIn_SedDens,'String',rhob);


        set(handles.SedSS_Slider,'Value',ssbot);
        set(handles.SedDens_Slider,'Value',rhob );
        set(handles.SedType,'Value',IND+1);

        plot(theta,Refl_dB)
        SetAxis;
    elseif (obj == handles.SedSS_Slider);

        handles.ss = get(handles.SedSS_Slider,'Value');
        set(handles.TextIn_SedSS,'String',handles.ss);
        GS = Cb2Mz(handles.ss);

        [SedType,IND]  = Phi2SedType(GS);
        [vr,rhor,rhob,rhow,delta,Refl,Refl_dB,theta,ssbot,Cw] = Mz2GAP(GS);

        set(handles.SedType,'Value',IND+1);
        set(handles.TextIn_SedDens,'String',rhob);
        set(handles.TextIn_GrainSize,'String',GS);

        set(handles.GS_Slider,'Value',GS);
        set(handles.SedDens_Slider,'Value',rhob );
        set(handles.SedType,'Value',IND+1);

        plot(theta,Refl_dB)
        SetAxis;


    elseif(obj == handles.SedType)
        grsize = [-1:.5:8 9];
        indx = get(handles.SedType,'Value');
        if (indx == 1)
            warndlg('Select Grain Size from pull-down menu.','!! Warning !!')
        else
            GS = grsize(indx-1);

            [vr,rhor,rhob,rhow,delta,Refl,Refl_dB,theta,ssbot,Cw] = Mz2GAP(GS);
            [SedType,IND]  = Phi2SedType(GS);

            set(handles.TextIn_SedSS,'String',ssbot);
            set(handles.TextIn_SedDens,'String',rhob);
            set(handles.TextIn_GrainSize,'String',GS);

            set(handles.GS_Slider,'Value',GS);
            set(handles.SedDens_Slider,'Value',rhob );
            set(handles.TextIn_GrainSize,'String',GS);
            plot(theta,Refl_dB)
            SetAxis;
        end
    elseif(obj == handles.SedDens_Slider)

        Rhob = get(handles.SedDens_Slider,'Value');
        GS = SedDens2Mz(Rhob);
        [SedType,IND]  = Phi2SedType(GS);

        [vr,rhor,rhob,rhow,delta,Refl,Refl_dB,theta,ssbot,Cw] = Mz2GAP(GS);

        set(handles.SedType,'Value',IND+1);
        set(handles.TextIn_SedSS,'String',ssbot);
        set(handles.TextIn_GrainSize,'String',GS);
        
        set(handles.GS_Slider,'Value',GS);
        set(handles.TextIn_SedDens,'String',rhob);
        plot(theta,Refl_dB)
        SetAxis;
    end
end

