function varargout = ModelParms(varargin)
% MODELPARMS M-file for ModelParms.fig
%      MODELPARMS, by itself, creates a new MODELPARMS or raises the existing
%      singleton*.
%
%      H = MODELPARMS returns the handle to a new MODELPARMS or the handle to
%      the existing singleton*.
%
%      MODELPARMS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MODELPARMS.M with the given input arguments.
%
%      MODELPARMS('Property','Value',...) creates a new MODELPARMS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before ModelParms_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to ModelParms_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help ModelParms

% Last Modified by GUIDE v2.5 26-Jul-2009 17:25:51

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @ModelParms_OpeningFcn, ...
                   'gui_OutputFcn',  @ModelParms_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before ModelParms is made visible.
function ModelParms_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to ModelParms (see VARARGIN)

% Choose default command line output for ModelParms

global TitleEnv freq SSP Bdry Pos Beam cInt RMax

handles.output = hObject;

set( handles.Nbeams,   'String', num2str( Beam.Nbeams ) )
set( handles.Angle1,   'String', num2str( Beam.alpha( 1   ) ) )
set( handles.Angle2,   'String', num2str( Beam.alpha( end ) ) )

set( handles.cLow,     'String', num2str( cInt.Low ) )
set( handles.cHigh,    'String', num2str( cInt.High ) )

set( handles.TitleEnv, 'String', TitleEnv )

switch Beam.RunType(1:1)
   case { 'C' }
      set( handles.SelectCoherent,     'Value', 1 )
   case { 'S' }
      set( handles.SelectSemiCoherent, 'Value', 1 )
   case { 'I' }
      set( handles.SelectIncoherent,   'Value', 1 )
end

switch Beam.RunType(2:2)
   case { 'G' }
      set( handles.SelectGeometric,       'Value', 1 )
   case { 'B' }
      set( handles.SelectGaussian,        'Value', 1 )
   case { 'C' }
      set( handles.SelectGaussianCerveny, 'Value', 1 )
end

% SSP interpolation
switch Bdry.Top.Opt(1:1)
   case { 'C' }
      set( handles.C, 'Value', 1 )
   case { 'N' }
      set( handles.N, 'Value', 1 )
   case { 'S' }
      set( handles.S, 'Value', 1 )
   case { 'I' }
      set( handles.Q, 'Value', 1 )
end

% Thorpe attenuation
if ( Bdry.Top.Opt( 4:4 ) == 'T')
   set( handles.Thorpe, 'Value', 1 );
end


% Update handles structure
guidata(hObject, handles);

% UIWAIT makes ModelParms wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = ModelParms_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


function Nbeams_Callback(hObject, eventdata, handles)
% hObject    handle to Nbeams (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Nbeams as text
%        str2double(get(hObject,'String')) returns contents of Nbeams as a double
global TitleEnv freq SSP Bdry Pos Beam cInt RMax

Beam.Nbeams = str2double( get( handles.Nbeams, 'String' ) );


% --- Executes during object creation, after setting all properties.
function Nbeams_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Nbeams (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
   set(hObject,'BackgroundColor','white');
end

function Angle1_Callback(hObject, eventdata, handles)
% hObject    handle to Angle1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Angle1 as text
%        str2double(get(hObject,'String')) returns contents of Angle1 as a double

global TitleEnv freq SSP Bdry Pos Beam cInt RMax

Angle1 = str2double( get( handles.Angle1, 'String' ) );
Beam.alpha = linspace( Angle1, Beam.alpha( end ), 2 );

% --- Executes during object creation, after setting all properties.
function Angle1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Angle1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
   set(hObject,'BackgroundColor','white');
end

function Angle2_Callback(hObject, eventdata, handles)
% hObject    handle to Angle2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Angle2 as text
%        str2double(get(hObject,'String')) returns contents of Angle2 as a double

global TitleEnv freq SSP Bdry Pos Beam cInt RMax

Angle2 = str2double( get( handles.Angle2, 'String' ) );
Beam.alpha = linspace( Beam.alpha( 1 ), Angle2, 2 );


% --- Executes during object creation, after setting all properties.
function Angle2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Angle2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
   set(hObject,'BackgroundColor','white');
end


function cLow_Callback(hObject, eventdata, handles)
% hObject    handle to cLow (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cLow as text
%        str2double(get(hObject,'String')) returns contents of cLow as a double
global TitleEnv freq SSP Bdry Pos Beam cInt RMax
global EnvChanged

cInt.Low = str2double( get( handles.cLow, 'String' ) );
EnvChanged = 1;
guidata( hObject, handles ); % Update handles structure

% --- Executes during object creation, after setting all properties.
function cLow_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cLow (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
   set(hObject,'BackgroundColor','white');
end

function cHigh_Callback(hObject, eventdata, handles)
% hObject    handle to cHigh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cHigh as text
%        str2double(get(hObject,'String')) returns contents of cHigh as a double
global TitleEnv freq SSP Bdry Pos Beam cInt RMax
global EnvChanged

cInt.High = str2double( get( handles.cHigh, 'String' ) );
EnvChanged = 1;
guidata( hObject, handles ); % Update handles structure

% --- Executes during object creation, after setting all properties.
function cHigh_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cHigh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
   set(hObject,'BackgroundColor','white');
end



function TitleEnv_Callback(hObject, eventdata, handles)
% hObject    handle to TitleEnv (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of TitleEnv as text
%        str2double(get(hObject,'String')) returns contents of TitleEnv as a double

global TitleEnv freq SSP Bdry Pos Beam cInt RMax

TitleEnv = get( handles.TitleEnv, 'String' );
guidata( hObject, handles ); % Update handles structure


% --- Executes during object creation, after setting all properties.
function TitleEnv_CreateFcn(hObject, eventdata, handles)
% hObject    handle to TitleEnv (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in SelectCoherent.
function SelectCoherent_Callback(hObject, eventdata, handles)
% hObject    handle to SelectCoherent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of SelectCoherent

global TitleEnv freq SSP Bdry Pos Beam cInt RMax

Beam.RunType(1:1) = 'C';


% --- Executes on button press in SelectSemiCoherent.
function SelectSemiCoherent_Callback(hObject, eventdata, handles)
% hObject    handle to SelectSemiCoherent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of SelectSemiCoherent

global TitleEnv freq SSP Bdry Pos Beam cInt RMax

Beam.RunType(1:1) = 'S';

% --- Executes on button press in SelectIncoherent.
function SelectIncoherent_Callback(hObject, eventdata, handles)
% hObject    handle to SelectIncoherent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of SelectIncoherent

global TitleEnv freq SSP Bdry Pos Beam cInt RMax

Beam.RunType(1:1) = 'I';


% --- Executes on button press in SelectGeometric.
function SelectGeometric_Callback(hObject, eventdata, handles)
% hObject    handle to SelectGeometric (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of SelectGeometric

global TitleEnv freq SSP Bdry Pos Beam cInt RMax

Beam.RunType(2:2) = 'G'


% --- Executes on button press in SelectGaussian.
function SelectGaussian_Callback(hObject, eventdata, handles)
% hObject    handle to SelectGaussian (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of SelectGaussian

global TitleEnv freq SSP Bdry Pos Beam cInt RMax

Beam.RunType(2:2) = 'B';


% --- Executes on button press in SelectGaussianCerveny.
function SelectGaussianCerveny_Callback(hObject, eventdata, handles)
% hObject    handle to SelectGaussianCerveny (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of SelectGaussianCerveny

global TitleEnv freq SSP Bdry Pos Beam cInt RMax

Beam.RunType(2:2) = 'C';



function RMax_Callback(hObject, eventdata, handles)
% hObject    handle to RMax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of RMax as text
%        str2double(get(hObject,'String')) returns contents of RMax as a double
global TitleEnv freq SSP Bdry Pos Beam cInt RMax
global EnvChanged

RMax = str2double( get( handles.RMax, 'String' ) );
EnvChanged = 1;
guidata( hObject, handles ); % Update handles structure

% --- Executes during object creation, after setting all properties.
function RMax_CreateFcn(hObject, eventdata, handles)
% hObject    handle to RMax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in Thorpe.
function Thorpe_Callback(hObject, eventdata, handles)
% hObject    handle to Thorpe (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Thorpe

global Bdry

if ( get( hObject, 'Value' ) == 1 )
   Bdry.Top.Opt( 4:4 ) = 'T';
else
   Bdry.Top.Opt( 4:4 ) = ' ';
end


% --------------------------------------------------------------------
function SSPtype_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to SSPtype (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in C.
function C_Callback(hObject, eventdata, handles)
% hObject    handle to C (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of C

global Bdry

if ( get( hObject, 'Value' ) == 1 )
   Bdry.Top.Opt( 1:1 ) = 'C';
end

% --- Executes on button press in N.
function N_Callback(hObject, eventdata, handles)
% hObject    handle to N (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of N

global Bdry

if ( get( hObject, 'Value' ) == 1 )
   Bdry.Top.Opt( 1:1 ) = 'N';
end


% --- Executes on button press in S.
function S_Callback(hObject, eventdata, handles)
% hObject    handle to S (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of S

global Bdry

if ( get( hObject, 'Value' ) == 1 )
   Bdry.Top.Opt( 1:1 ) = 'S';
end

% --- Executes on button press in Q.
function Q_Callback(hObject, eventdata, handles)
% hObject    handle to Q (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Q

global Bdry

if ( get( hObject, 'Value' ) == 1 )
   Bdry.Top.Opt( 1:1 ) = 'Q';
end
