from numpy import *
from math import atan2, sin


def EPS(x):
	x = abs(x)
	e = 1
	temp = x + e
	while(temp != x):
		e = e*.5
		temp = x + e
	e = 2*e
	return e

def trace( SSP, deltas, xs, alpha, Amp0, BeamType, Box, RunType, Tr, Bt):
	global tr, bt
	global Layer
	bt = Bt
	tr = Tr
	#global ray, Nsteps, Bdry, Layer
	#global xTop, tTop, nTop, tTopNode, nTopNode, RLenTop, kappaTop, NatiPts, atiType
	#global xBot, tBot, nBot, tBotNode, nBotNode, RlenBot, kappaBot, NbtyPts, btyType
	#global topFlag, botFlag
	#Traces the beam corresponding to a particular take-off angle
	#Initial conditions
	
	Layer =1
	[ c, gradc, crr, crz, czz, Layer ] = ssp( xs, SSP, Layer )
	
	bt.Nsteps       = 0
	MaxSteps     = 100000
	bt.ray[0][0]    = c
	bt.ray[0][1]    = xs
	bt.ray[0][2]    = array([cos(alpha), sin(alpha)])/c
	bt.ray[0][3]    = array([1.0, 0.0])
	bt.ray[0][4]    = array([0.0, 1.0])
	bt.ray[0][5]    = 0
	bt.ray[0][6]    = Amp0
	
	#second componenet of qv is not used in geometric beam tracing
	#set I.C. to 0 in hopes of saving run time
	if (RunType[1] == 'G'):
		bt.ray[0][7] = zeros((1,2))
	
	#*****identify the top segment above the source****
	
	IsegTopT = where(tr.xTop[ 0, 0:tr.NbtyPts-1] <= xs[ 0 ])[0]
	
	if ((IsegTopT[-1]+1 > 0) and (IsegTopT[-1]+1 < tr.NatiPts)):
		IsegTop = IsegTopT[-1] # IsegBot MUST LIE IN [ 0, tr.NbtyPts-2 ]
		rTopSeg = [tr.xTop[0,IsegTop],tr.xTop[0,IsegTop + 1]]
	else:
		print('Fatal Error: Top altimetry undefined above the source')
   
	#*****identify the bottom segment below the source****
	
	IsegBotT = where(tr.xBot[ 0, 0:tr.NbtyPts] <= xs[ 0 ])[0] 
	
	if ((IsegBotT[-1]+1 > 0) and (IsegBotT[-1]+1 < tr.NbtyPts)):
		IsegBot = IsegBotT[-1] # IsegBot MUST LIE IN [ 0, tr.NbtyPts-2 ]
		rBotSeg = [tr.xBot[0,IsegBot],tr.xBot[0,IsegBot + 1]]
	else:
		print('Fatal Error: Bottom bathymetry undefined below the source')
	
	#*******Trace the beam ******
	
	for I in range(MaxSteps): 
		I0 = I
		I1 = I + 1
		# make sure shape is correct
		bt.ray[I1][0]   = c
		bt.ray[I1][4]   = array([0.0,1.0])
		# need to ensure q( 1 ) exists in INFLUG for caustic count
		bt.ray[I1][5] = 0
		bt.ray[I1][6] = 1
		
		[ bt.ray[I1][1], bt.ray[I1][2], bt.ray[I1][3], bt.ray[I1][4], bt.ray[I1][5], bt.ray[I1][6], bt.ray[I1][0] ] = \
		step( SSP, bt.ray[I0][1], bt.ray[I0][2], bt.ray[I0][3], bt.ray[I0][4], bt.ray[I0][5], bt.ray[I0][6], \
		tr.xTop[ :, IsegTop ].T, tr.nTop[ :, IsegTop ].T, \
		tr.xBot[ :, IsegBot ].T, tr.nBot[ :, IsegBot ].T,  rTopSeg, rBotSeg, deltas )
		
		
		#******new altimetry segment?********
		if ( (bt.ray[I1][1][0] < rTopSeg[0]) or (bt.ray[I1][1][0] > rTopSeg[1]) ):
			IsegTopT = where((tr.xTop[0,:] < bt.ray[I1][1][0])!=0)[0]
			if (bool(list(IsegTopT))==False):
				IsegTop = 0
			else:
				IsegTop = min(IsegTopT[-1], tr.NatiPts -2)
			rTopSeg = array([tr.xTop[0,IsegTop],tr.xTop[0,IsegTop+1] ])
		
		#********New Bathymetry segment? ******
		if ( (bt.ray[I1][1][0] < rBotSeg[0]) or (bt.ray[I1][1][0] > rBotSeg[1]) ):
			IsegBotT = where((tr.xBot[0,:] < bt.ray[I1][1][0])!=0)[0]
			if (bool(list(IsegBotT))==False):
				IsegBot = 0
			else:
				IsegBot = min(IsegBotT[-1], tr.NbtyPts -2)
			rBotSeg = array([tr.xBot[0,IsegBot],tr.xBot[0,IsegBot+1] ])
			
		#******Reflections?*******
		#Tests that ray at step i is inside, and ray at step i+1 is outside
		#to detect only a crossing from inside to outside
	
	
		DBegTop   = bt.ray[I][1] - tr.xTop[:,IsegTop].T #vector pointing from top to ray
		DBegBot   = bt.ray[I][1] - tr.xBot[:,IsegBot].T #vector pointing from bottom to ray
		DistBegTop = dot(DBegTop,tr.nTop[:,IsegTop])
		DistBegBot = dot(DBegBot,tr.nBot[:,IsegBot])
	
		DEndTop    = bt.ray[I1][1] - tr.xTop[:,IsegTop].T  # vector pointing from top    to ray
		DEndBot    = bt.ray[I1][1] - tr.xBot[:,IsegBot].T # vector pointing from bottom to ray
		DistEndTop = dot(DEndTop,tr.nTop[:,IsegTop])
		DistEndBot = dot(DEndBot,tr.nBot[:,IsegBot])
		
		if ((float(DistBegTop) < 0.0) and (float(DistEndTop) >= 0.0)):
			#interpolate top normal and tangent by proportional distance
			#along the segment 
			if (tr.atiType == 'C'): # curvilinear
				sss     = dot(DEndTop.T, tr.tTop[:,IsegTop])
				alpha   = sss/tr.RLenTop[IsegTop]
				nTopInt = (1 - alpha)*tr.nTopNode[:,IsegTop] + alpha*tr.nTopNode[:,IsegTop+1]
				tTopInt = (1 - alpha)*tr.tTopNode[:,IsegTop] + alpha*tr.tTopNode[:,IsegTop+1]
			else:       # linear
				nTopInt = tr.nTop[:,IsegTop]
				tTopInt = tr.tTop[:,IsegTop]
			BC = tr.Bdry.Top.Opt[1]
			temp = 'TOP'
			if (tr.topFlag == True):
				reflect( I1, BeamType, BC, tr.Bdry.Top.cp, tr.Bdry.Top.rho, temp, \
				tTopInt.T, nTopInt.T, tr.kappaTop[IsegTop][0], SSP )
			else:
				reflect( I1, BeamType, BC, tr.Bdry.Top.cp, tr.Bdry.Top.rho, temp, \
				tTopInt.T, nTopInt.T, tr.kappaTop[IsegTop], SSP )
		if ((float(DistBegBot) < 0.0) and (float(DistEndBot) >= 0.0)):
			# interpolate bottom normal and tangent by proportional distance along the segment
			if (tr.btyType == 'C'):  #curvilinear
				sss     = dot(DEndBot.T,tr.tBot[:,IsegBot])
				alpha   = sss/tr.RLenTop[IsegBot]
				nBotInt = (1-alpha)*tr.nBotNode[:,IsegBot] + alpha*tr.nBotNode[:,IsegBot+1]
				tBotInt = (1-alpha)*tr.tBotNode[:,IsegBot] + alpha*tr.tBotNode[:,IsegBot+1]
			else:     #linear
				nBotInt = tr.nBot[:,IsegBot]
				tBotInt = tr.tBot[:,IsegBot]
			BC = tr.Bdry.Bot.Opt[0]
			temp = 'BOT'
			
			if (tr.botFlag == True):
				reflect(I1,BeamType,BC,tr.Bdry.Bot.cp,tr.Bdry.Bot.rho,temp, \
				tBotInt.T, nBotInt.T, tr.kappaBot[IsegBot][0], SSP )
			else:
				reflect(I1,BeamType,BC,tr.Bdry.Bot.cp,tr.Bdry.Bot.rho,temp, \
				tBotInt.T, nBotInt.T, tr.kappaBot[IsegBot], SSP )
				
		#*** Has the ray left the box, losts its energy, or exceeded storage limit?**
		if ((abs(bt.ray[I1][1][0]) > Box.r) or \
		(bt.ray[I1][1][1] > Box.z) or (abs(bt.ray[I1][6]) < 0.005)):
			bt.Nsteps = I1
			return [bt.ray, bt.Nsteps, tr.Bdry]
		
	#Next Step 
	bt.Nsteps = MaxSteps
	print('bellhop:trace: Terminating ray trace at limit of MaxSteps = %i \n'% (MaxSteps) )
	return [bt.ray, bt.Nsteps, tr.Bdry]

def ssp(x, SSP, Layer):
    #ssp tabulates the sound speed profile and its derivatives 
    #also returns a vector Layer indicating the layer a depth 
    #point its in
    
    #Layer is the index of the layer that each ray is in 
    #[SSP.z, SSP.c] contains the depth/sound speed values 
    #all vectors are set up as column vectors...
    #x can be a vector or a scalar

	NSSPLayers = len(SSP.z)-1
    #search through deeper layers
	while ((x[1]>=SSP.z[Layer]) and (Layer < NSSPLayers)):
		Layer = Layer + 1
	#search through shallower layers
	while ((x[1] < SSP.z[Layer - 1]) and (Layer >1)):
		Layer = Layer - 1
	
	w = x[1] - SSP.z[Layer -1] # distance into layer
	cz = SSP.cz[Layer - 1]
	c = SSP.c[Layer -1] + w*cz
	
	gradc = [0.0,cz]
	crr = 0
	crz = 0
	czz = 0
	return [c, gradc, crr, crz, czz, Layer]

def reflect(I,BeamType,BC,cHS,rhoHS,BotTop,TBdry,NBdry,kappa,SSP):
	#reflect a ray/beam off a boundary
	global tr, bt
	global Layer
	#global ray, omega, Layer
	RADDEG = 180/pi # used to convert radians into degrees
	
	Tg = dot(bt.ray[I][2].T,TBdry.T) #component of ray tangent, along boundary
	Th = dot(bt.ray[I][2].T,NBdry.T) #component of ray tangent, normal to boundary
	
	# ****calculate the change in curvature*******
	#based on formulas given by Muller, Geoph. J. R.A.S., 79 (1984)
	
	[c,gradc,crr,crz,czz, ayer] = ssp( bt.ray[I][1][:],SSP,Layer)
	cn = gradc[1]*bt.ray[I][2][0]
	cs = gradc[1]*bt.ray[I][2][1]
	
	RN = 2*kappa/c**2/Th #Boundary curvature correction
	if (BotTop == 'TOP'):
		cn = -cn #flip sign for top reflection
		RN = -RN
	RM = Tg/Th
	RN = RN + RM.T*(4*cn - 2*RM.T*cs)/c #*********these are not vectors!!********
	
	if (BeamType[1] == 'D'):
		RN = 2.0*RN
	elif (BeamType[1] == 'Z'):
		RN = 0.0
	
	bt.ray[I][2][0] = bt.ray[I][2][0] - 2.0*(Th*NBdry[0].T).T
	bt.ray[I][2][1] = bt.ray[I][2][1] - 2.0*(Th*NBdry[1].T).T
	
	bt.ray[I][3][0] = bt.ray[I][3][0] + bt.ray[I][4][0]* RN
	bt.ray[I][3][1] = bt.ray[I][3][1] + bt.ray[I][4][1]* RN
	
	
	#******account for phase change*******
	
	#if (BC == 'R'): # rigid
	
	if (BC == 'V'): #vacuum
		bt.ray[I][6] = -bt.ray[I][6]
	if (BC == 'F'): #file
		theInt = RADDEG*abs(atan2(Th,Tg)) #angle of incidence (relative to normal to bathymetry)
		#[ theta, RefC, phi ] = RefCO( theInt, rInt, phiInt, Npts  )
		bt.ray[I][6] = bt.ray[I][6]*rInt*exp(1j*phiInt)
	if (BC == 'A'): #half-space
		GK       = bt.omega*Tg #wavenumber in direction parallel to bathymetry
		gamma1SQ = (bt.omega/c.T)**2 - GK**2
		gamma2SQ = (bt.omega/cHS)**2 - GK**2
		gamma1   = sqrt(-gamma1SQ)
		gamma2   = sqrt(-gamma2SQ)
		Refl = (rhoHS*gamma1 - gamma2)/(rhoHS*gamma1 + gamma2)
		bt.ray[I][6] = Refl.T*bt.ray[I][6] # use to be Refl.' .*
	
		#if ( abs( ray( I ).Rfa ) < 1.0E-5 )   % kill a ray that has lost its energy in reflection
			#%ray( I ).Rfa = 0.0;
        #%end
      
def step( SSP, x0, Tray0, p0, q0, tau0, Rfa0, \
xTop, nTop, xBot, nBot,  rTopSeg, rBotSeg, deltas ):
	
	# Does a single step along the ray
	# x denotes the ray coordinate, (r,z)
	# Tray denotes the scaled tangent to the ray
	global Layer
	
	# ***phase 1 of modified polgon meythod (an Euler step)***
	[c0, gradc0, crr0, crz0, czz0, Layer] = ssp(x0, SSP, Layer)
	csq0 = c0*c0
	cnn0_csq0 = crr0*Tray0[1]**2 - 2.0*crz0*Tray0[0]*Tray0[1] + czz0*Tray0[0]**2
   
	#make note of current layer
	Layer0 = Layer
	#initially set the step h, to the basic one, deltas
	h = deltas
	h = reducestep(SSP, x0, Tray0, Layer0, c0, xTop, nTop, xBot, nBot,  rTopSeg,\
	rBotSeg, deltas, h )
   
	#first step of the modified polygon method is a half step
	halfh = 0.5*h
	gradc0 = array(gradc0)
	x1    = x0    + halfh*c0*Tray0
	Tray1 = Tray0 - halfh*gradc0/csq0
	p1    = p0    - halfh*cnn0_csq0*q0
	q1    = q0    + halfh*c0*p0
	#*****Phase 2 of modified polygon method****

	[ c1, gradc1, crr1, crz1, czz1, Layer ] = ssp( x1, SSP, Layer )
	csq1 = c1*c1
	cnn1_csq1 = crr1*Tray1[1]**2 - 2.0*crz1*Tray1[0]*Tray1[1] + czz1*Tray1[0]**2
   
	h = reducestep( SSP, x0, Tray1, Layer0, c1, xTop, nTop, xBot, nBot,  rTopSeg,\
	rBotSeg, deltas, h )
   
	#use blend of f' based on proportion of a full step used
	
	w1 = h*h/(double(2.0)*halfh)
	w0 = h*double(1.0) - w1
	
	#you could absorb h into w0, w1 but I leave as follows for clarity, 
	#hoping compiler is smart enough to optimize
	
	gradc1 = array(gradc1)
	x2     = x0    +  w0 * c0 * Tray0     + w1 * c1 * Tray1     
	Tray2  = Tray0 -  w0 * gradc0 / csq0  - w1 * gradc1 / csq1  
	p2     = p0    -  w0 * cnn0_csq0 * q0 - w1 * cnn1_csq1 * q1 
	q2     = q0    +  w0 * c0        * p0 + w1 * c1        * p1 
	tau2   = tau0  +  w0 / c0             + w1 / c1             
	
	Rfa2   = Rfa0
   
	#If we crossed an interface, apply jump condition
	[ c2, gradc2, crr2, crz2, czz2, Layer ] = ssp( x2, SSP, Layer )
   
	if (Layer != Layer0):
		RN = -Tray2[0]**2/Tray2[1] * (gradc2[1] - gradc0[1])/c0   
		#above needs updating for c(r,z) problem
		p2 = p2 + q2*RN
   
	return [ x2, Tray2, p2, q2, tau2, Rfa2, c2 ]
   
def reducestep(SSP,x0,Tray,Layer0,c,xTop,nTop,xBot,nBot,rTopSeg,rBotSeg,deltas,h):
	
	h = float(h)
	deltas = float(deltas)
	x = x0 + h*c*Tray;  # make a trial step
	Layer1 = Layer0
	Layer0 = Layer0-1
	#*** Detect interface or boundary crossing

	#*** Adjust step to land on an interface or boundary
	
	hLayer = inf
	if (x[1] < SSP.z[Layer0]):
		hLayer = (SSP.z[Layer0] - x0[1])/(Tray[1]*c)
	
	#Layer1 = Layer0 + 1
	
	if (x[1] > SSP.z[Layer1]):
		hLayer = (SSP.z[Layer1] - x0[1])/(Tray[1]*c)
	
	# top crossing
	hTop = inf
	d = x - xTop.T  #vector from top to ray endpoint
	
	if (dot(d,nTop) > 0): # top crossing
		e = x0 - xTop # vector from top to ray origin
		hTop = dot(-e,nTop)/(c*dot(Tray,nTop))
	
	#bottom crossing
	hBot = inf
	d    = x - xBot.T  #vector from bottom to ray endpoint
	
	if (dot(d,nBot) > 0): # bottom crossing
		e = x0 - xBot #vector from bottom to ray origin
		hBot = dot(-e,nBot)/(c*dot(Tray,nBot))
		
		
	#top segment crossing in range
	h4 = inf
	h5 = inf
	if (Tray[0] != 0):
		if (x[0] < rTopSeg[0]):
			h4 = -(x0[0] - rTopSeg[0])/(Tray[0]*c)
		elif (x[0] > rTopSeg[1]):
			h4 = -(x0[0] - rTopSeg[1])/(Tray[0]*c)
	
		#bottom segment crossing in range
		if (x[0] < rBotSeg[0]):
			h5 = -(x0[0] - rBotSeg[0])/(Tray[0]*c)
		elif (x[0] > rBotSeg[1]):
			h5 = -(x0[0] - rBotSeg[1])/(Tray[0]*c)
	
	h = min([h,hLayer,hTop,hBot,h4,h5]) # step is limited by the smaller of an interface or bottom crossing
	h = max(h,10000*EPS(deltas));   # make sure we make some motion		
	return h
def scalep(Dalpha, c, r, U, RunType, TopOpt, freq):
	
	#scale the pressure field
	
	# compute scale factor
	if (RunType[1] == 'C'):
		const = -Dalpha*sqrt(freq)/c
	elif(RunType[1] == 'R'):
		const = -Dalpha*sqrt(freq)/c
	else:
		const = -1.0
	#Thorpe attenuation?
	if (TopOpt[3] == 'T'):
		f2 = (freq/1000.0)**2
		alpha = 40.0*f2/(4100.0 + f2) + 0.1*f2/(1.0 + f2)
		alpha = alpha/914.4  # dB/m
		alpha = alpha/8.6858896 # Nepers/m
	else:
		alpha = 0.0
	
	#for incoherent RunType, convert intensity to pressure
	if (RunType[0] != 'C'):
		U = sqrt(real(U))
	#add in attenuation
	for ir in range(len(r)):
		if (RunType[3] == 'X'): # line source
			factor = -4*sqrt(pi)*const
		else:
			if (r[ir] != 0):
				factor = const*exp(-alpha*r[ir])/sqrt(complex(r[ir]))
			else:
				factor = 0.0
		U[:,ir] = factor*U[:,ir]
		
	return U
def influg(zs, alpha, RunType, Dalpha):
	
	global tr, bt
	
	#global ray, Nsteps, omega
	#global Pos
	#global U, MxNarr
	
	#Computes the beam influence, i.e.
	#the contribution of a single beam to the complex pressure
	#This version uses a beam representation in Cartesian coordinates
	
	#Some ugly code to have RunType 'a' treated like 'A'
	RunTypeE = RunType[0]
	if (RunTypeE == 'a'):
		RunTypeE = 'A'
	
	zs    = float(zs)
	DS      = sqrt(2.0)*sin(float(bt.omega)*zs*float(bt.ray[0][2][1]))
	if (shape(bt.ray[0][0])==()):
		q0      = bt.ray[0][0]/Dalpha  # reference for J = Q0 / Q
	else:
		q0      = bt.ray[0][0][0]/Dalpha  # reference for J = Q0 / Q
	caustic = 1 # caustic is multiplied by i after each caustic
	
	if (RunType[3] == 'R'):  #point source
		Rat1 = sqrt(abs(cos(alpha)))
		
	else:
		Rat1 = 1
	
	# Step along beams
	if (shape(bt.Nsteps)==()):
		nsteps = bt.Nsteps
	else:
		nsteps = max(bt.Nsteps)
	
	for s in range(nsteps-1):
		
		if (s > 1):
			if (  ( (bt.ray[s][4][0] <= 0.0) and (bt.ray[s-1][4][0] > 0.0) ) \
			or ( (bt.ray[s][4][0] >= 0.0) and (bt.ray[s-1][4][0] < 0.0) )  ):
				caustic = 1.j*caustic # apply the caustic phase change
		
		#***** find indices of bracketted receiver ranges *****
		# following assumes r is uniformly spaced
		deltar = (bt.Pos.r.range[-1] - bt.Pos.r.range[0])/(len(bt.Pos.r.range)-1)
		if (real(bt.ray[s+1][1][0]) >= real(bt.ray[s][1][0])): # stepping to the right
			# python's commands 'floor' and 'ceil' cannot handle complex numbers
			ir1 = 1 + (bt.ray[s    ][1][0] - bt.Pos.r.range[0]) / deltar + EPS(bt.ray[s][1][0])
			ir2 = 1 + (bt.ray[s + 1][1][0] - bt.Pos.r.range[0]) / deltar
			ir1, ir2 = ceil(real(ir1)), floor(real(ir2))
			
			ir1 = max(ir1,1)
			ir2 = min(ir2, len(bt.Pos.r.range)) 
		else:  # stepping to the left
			ir1 = 1 + (bt.ray[s + 1][1][0] - bt.Pos.r.range[0]) / deltar + EPS(bt.ray[s][1][0])
			ir2 = 1 + (bt.ray[s    ][1][0] - bt.Pos.r.range[0]) / deltar
			ir1, ir2 = ceil(real(ir1)), floor(real(ir2))
			
			ir1 = max(ir1, 1 )
			ir2 = min(ir2, len( bt.Pos.r.range ) )
		
		if (ir1 <= ir2):
			for ir in (range(int(ir2-ir1+1))+(int(ir1-1))*ones(int(ir2-ir1+1))): # loop acros receiver ranges
				
				xray = array(ones(shape(mat(bt.Pos.r.depth))).T *mat(bt.ray[s][1]))
				tray = array(bt.ray[s+1][1] - bt.ray[s][1])
				rlen = sum(abs(tray)**2)**(.5) # in place of matlabs "norm(vector)"  
			
				tray = tray/ rlen
				tray_scaled = tray/ rlen
			
				nray = array([-tray[1], tray[0]]) # unit normal to tray
				xrcvr = zeros( (len(bt.Pos.r.depth),2) )
				xrcvr[:,0] = bt.Pos.r.range[ir]*ones(len(bt.Pos.r.depth)).T
				xrcvr[:,1] = bt.Pos.r.depth.T
			
				S      = mat(xrcvr - xray)*mat(tray_scaled).T  # proportional distance along ray
				n      = abs(mat(xrcvr - xray)*mat(nray).T)   # normal distance to ray
				q      = bt.ray[s][4][0] + S*(bt.ray[s+1][4][0] - bt.ray[s][4][0]) #amplitude
				RadMax = abs(q/q0)   # beam radius
				#print(where((n < RadMax)!=0))
			
				ird = where((n < RadMax)!=0)[0][0]
			
				if (shape(ird) != (1,0)):
					
				
					A     = 1/RadMax[ird]
					c     = bt.ray[s][0]   + S[ird]*(bt.ray[s+1][0]   - bt.ray[s][0])#sound speed
					delay = bt.ray[s][5] + S[ird]*(bt.ray[s+1][5] - bt.ray[s][5])
				
					#identify beams that have crossed a caustic
				
					caust = caustic*ones( shape(ird) )
				
					#ird = map(int,ird)
					ii = where( ( (array(q)[ird]<=0.0)[0][0]*(bt.ray[s][4][0]>0.0) ) + ( (array(q)[ird]>=0.0)[0][0]*(bt.ray[s][4][0]<0.0) ) )
					#ii = ( (q[ird] <= 0.0) and (bt.ray[s][4][0] > 0.0) )\
					#or   ( (q[ird] >= 0.0) and (bt.ray[s][4][0] < 0.0) ) 
					if (shape(ii)!=(1,0)):
						caust[ii] = 1.j*caust[ii] # apply the caustic phase change
				
					const = Rat1*bt.ray[s][6] * real( sqrt( array(1/abs(q[ird]))*array(c) ) )*array(A)*array(caust)
				
					if (RunTypeE == 'S'): # Coherent, semi-coherent, or incoherent TL:
						const = DS*const
					amp = const*array(RadMax[ird] - n[ird])
					if (RunTypeE == 'A'): #arrivals
						angle = 180/pi*atan2(tray[1],tray[0])
						AddArr(bt.omega, ird, ir, amp, delay, angle, bt.MxNarr)
					elif(RunTypeE == 'C'): # coherent TL
						contri = amp*array(exp(-1.j*bt.omega*delay))
                        			bt.U[ird, ir] = bt.U[ird, ir] + contri
					else: # incoherent/ semi-coherent TL
                        			temp1 = array(RadMax[ird])-array(n[ird])
						temp2 = array((1/RadMax[ird]).T)
						W = temp1*temp2
						temp1 = 1/W
						temp2 = array(abs(amp))*temp1[0].T
						temp3 = (temp2**2).T*W
						contri = temp3[0].T
						bt.U[ird,ir] = bt.U[ird, ir] + contri[0]
					#close if/elif on RunTypeE
			#next receiver range, ir
	#next step, s
	return [bt.ray, bt.Nsteps, bt.omega, bt.Pos, bt.U]	

def influgrb(zs, alpha, RunType, Dalpha, deltas):
	global tr, bt
	
	#global ray, Nsteps, omega
	#global Pos
	#global U, MxNarr
	
	#Computes the beam influence, i.e.
	#the contribution of a single beam to the complex pressure
	#This version uses a beam representation in Cartesian coordinates
	IBWin = 4
	deltas = float(deltas)
	#Some ugly code to have RunType 'a' treated like 'A'
	RunTypeE = RunType[0]
	if (RunTypeE == 'a'):
		RunTypeE = 'A'
	
	zs    = float(zs)
	DS      = sqrt(2.0)*sin(float(bt.omega)*zs*float(bt.ray[0][2][1]))
	if (shape(bt.ray[0][0])==()):
		q0      = bt.ray[0][0]/Dalpha  # reference for J = Q0 / Q
		lam     = bt.ray[0][0]/(bt.omega/(2*pi))
	else:
		q0      = bt.ray[0][0][0]/Dalpha  # reference for J = Q0 / Q
		lam     = bt.ray[0][0]/(bt.omega/(2*pi))
	caustic = 1 # caustic is multiplied by i after each caustic
	
	if (RunType[3] == 'R'):  #point source
		Rat1 = sqrt(abs(cos(alpha)))/1.2535
		
	else:
		Rat1 = 1/1.2535
	
	# Step along beams
	if (shape(bt.Nsteps)==()):
		nsteps = bt.Nsteps
	else:
		nsteps = max(bt.Nsteps)
	counter1 = 0
	for s in range(nsteps-1):
		counter1 = counter1 + 1
		if (s > 1):
			if (  ( (bt.ray[s][4][0] <= 0.0) and (bt.ray[s-1][4][0] > 0.0) ) \
			or ( (bt.ray[s][4][0] >= 0.0) and (bt.ray[s-1][4][0] < 0.0) )  ):
				caustic = 1.j*caustic # apply the caustic phase change
		
		#***** find indices of bracketted receiver ranges *****
		# following assumes r is uniformly spaced
		deltar = (bt.Pos.r.range[-1] - bt.Pos.r.range[0])/(len(bt.Pos.r.range)-1)
		if (real(bt.ray[s+1][1][0]) >= real(bt.ray[s][1][0])): # stepping to the right
			# python's commands 'floor' and 'ceil' cannot handle complex numbers
			ir1 = 1 + (bt.ray[s    ][1][0] - bt.Pos.r.range[0]) / deltar + EPS(bt.ray[s][1][0])
			ir2 = 1 + (bt.ray[s + 1][1][0] - bt.Pos.r.range[0]) / deltar
			ir1, ir2 = ceil(real(ir1)), floor(real(ir2))
			
			ir1 = max(ir1,1)
			ir2 = min(ir2, len(bt.Pos.r.range)) 
		else:  # stepping to the left
			ir1 = 1 + (bt.ray[s + 1][1][0] - bt.Pos.r.range[0]) / deltar + EPS(bt.ray[s][1][0])
			ir2 = 1 + (bt.ray[s    ][1][0] - bt.Pos.r.range[0]) / deltar
			ir1, ir2 = ceil(real(ir1)), floor(real(ir2))
			
			ir1 = max( ir1, 1 )
			ir2 = min( ir2, len( bt.Pos.r.range ) )
		
		if (ir1 <= ir2):
			counter2 = 0
			for ir in (range(int(ir2-ir1+1))+(int(ir1-1))*ones(int(ir2-ir1+1))): # loop acros receiver ranges
				counter2 = counter2 + 1
				xray = array(ones(shape(mat(bt.Pos.r.depth))).T *mat(bt.ray[s][1]))
				tray = array(bt.ray[s+1][1] - bt.ray[s][1])
				rlen = sum(abs(tray)**2)**(.5) # in place of matlabs "norm(vector)"  
			
				tray = tray/ rlen
				tray_scaled = tray/ rlen
			
				nray = array([-tray[1], tray[0]]) # unit normal to tray
				xrcvr = zeros( (len(bt.Pos.r.depth),2) )
				xrcvr[:,0] = bt.Pos.r.range[ir]*ones(len(bt.Pos.r.depth)).T
				xrcvr[:,1] = bt.Pos.r.depth.T
			
				S      = mat(xrcvr - xray)*mat(tray_scaled).T  # proportional distance along ray
				n      = array(abs(mat(xrcvr - xray)*mat(nray).T))   # normal distance to ray
				q      = array(bt.ray[s][4][0] + S*(bt.ray[s+1][4][0] - bt.ray[s][4][0])) #amplitude
				sigma = abs(q/q0)   # beam radius
				ii = where(sigma < min(0.2*(s+1)*deltas/lam, pi*lam))[0]
				sigma[ii] = min(0.2*(s+1)*deltas/lam, pi*lam)
				ird = where(n < IBWin*sigma)[0]
				
				if (shape(ird) != (0,)):
					
					A     = abs(q0/q[ird])
					c     = array(bt.ray[s][0]   + S[ird]*(bt.ray[s+1][0]   - bt.ray[s][0]))#sound speed
					delay = array(bt.ray[s][5] + S[ird]*(bt.ray[s+1][5] - bt.ray[s][5]))
					
					#identify beams that have crossed a caustic
				
					caust = caustic*ones( shape(ird),complex )
					
					ii = where( ( (q[ird]<=0.0)*(bt.ray[s][4][0]>0.0) ) + ( (q[ird]>=0.0)*(bt.ray[s][4][0]<0.0) ) )[0]
					
					if (shape(ii)!=(0,)):
						#print(caust[ii])
						caust[ii] = 1.j*caust[ii] # apply the caustic phase change
					
					const = Rat1*bt.ray[s][6] * real( sqrt( 1/abs(q[ird])*c ) )*vstack(caust)
					
					if (RunTypeE == 'S'): # Coherent, semi-coherent, or incoherent TL:
						const = DS*const
					
					amp = const*exp(-0.5*(1/sigma[ird] * n[ird] )**2)/(2*sigma[ird]*A)
					
					if (RunTypeE == 'A'): #arrivals AddArr has not been written
						angle = 180/pi*atan2(tray[1],tray[0])
						AddArr(bt.omega, ird, ir, amp, delay, angle, bt.MxNarr)
					elif(RunTypeE == 'C'): # coherent TL
						
						contri = amp*exp(-1.j*bt.omega*delay)
						bt.U[ird, ir] = bt.U[ird, ir] + hstack(contri)
						
					else: # incoherent/ semi-coherent TL
						temp1 = (1/sigma[ird]*n[ird])**2
						temp2 = exp(-0.5*temp1)
						temp3 = 1/(2.0*sigma[ird]*A)
						W = temp2*temp3
						temp1 = (1/W*abs(amp))**2
						contri = temp1*W
						bt.U[ird,ir] = bt.U[ird, ir] + contri.T[0]
					#close if/elif on RunTypeE
			#next receiver range, ir
	#next step, s
	return [bt.ray, bt.Nsteps, bt.omega, bt.Pos, bt.U]