import pickle
from matplotlib.cm import jet_r,jet
import matplotlib.mlab as mlab
import matplotlib.pyplot as plt
from matplotlib import mpl
from numpy import *
import array as ar

class POS:
	def _init_(self):
		self.r = []
		self.s = []
		self.Nrd = 0
		self.Nsd = 0
		self.Nrr = 0
		
class R:
	def _init_(self):
		self.depth = []
		self.range = []
class S:
	def _init_(self):
		self.depth

def squeeze(a):
	shape = list(a.shape)
	if (len(shape) > 2):
		while( (shape.__contains__(1)) == True ):
			shape.remove(1)
		b = a.reshape(shape)
	else:
		b = a
	return b

def getLine(fid): 
	
	# reads a line removes commas, '/' , and '!' 
	s = fid.readline()
	S = s.replace(',', ' ')
	if (S.find('/')!= -1):
		S = S[0:S.find('/')]
	if (S.find('!') != -1):
		S = S[0:S.find('!'):]
	return S
	
def plotshd(filename, m,n,p,bounds=None):
	
	# plot a single TL surface in dB
	# usage:
	# plotshd(filename,m,n,p)
	# (m,n,p) optional subplot spec
	#'.shd' is the fault file extension if not specified
	
	#mbp
	
	#read
	
	itheta = 0
	isd    = 0
	
	[ PlotTitle, PlotType, freq, atten, Pos, pressure ] = read_shd( filename )
	
	pressure = squeeze( pressure[itheta,isd] )
	
	zt       = Pos.r.depth
	rt       = Pos.r.range
	xlab     = 'Range (km)'
	
	if (p == 1):
		plt.figure()
	
	plt.subplot(m,n,p)
	
	tlt = abs(pressure)
	
	while (tlt.__contains__(inf)): # remove infinities
		tlt[tlt.index(inf)] = 1e-6
	while (tlt.__contains__(NaN)): # remove NaNs
		tlt[tlt.index(nan)] = 1e-6
	
	ii      = where(tlt < 1e-7)  #find places where pressure vanishes
	icount  = where(tlt > 1e-7)  #for stats, only these values count
	tlt[ii] = 1e-7               # and set it to a small number
	tlt = -20.0*log10(tlt)       #so there's no error when we take the log

	# compute some statistics to automatically set the color bar
	if (bounds == None):
		tlmed = median(tlt[icount])  #median value
		tlstd = std(tlt[icount])     #standard deviation
		tlmax = tlmed + 0.75*tlstd   #max for colorbar
		tlmax = 10*round(tlmax/10)   #make sure the limits are round numbers
		tlmin = tlmax - 50           #min for colorbar
	else:
		tlmin = bounds[0]
		tlmax = bounds[1]
	# optionally remove cylindrical spreading:
	
	if ( (len(tlt[:,0]) > 1) and (len(tlt[:,1]) > 1) ):
		
		plt.ylim(float(max(Pos.r.depth)) , -1000.0)
		NORM = mpl.colors.Normalize(vmin=tlmin, vmax=tlmax)
		plt.pcolor(rt/1000,zt,tlt, cmap=jet_r,norm = NORM,shading='flat')
		plt.colorbar()
		plt.title(PlotTitle + '\n Freq = '+str(freq)+' Hz   Sd = '+str(Pos.s.depth)+ ' m')
		plt.xlabel(xlab)
		plt.ylabel('Depth (m)')
	
def read_shd(filename):
	#Read the shade file
	# calls the appropriate routine (binary, ascii, or mat file) to read in the pressure field
	# usage: [ PlotTitle, PlotType, freq, atten, Pos, p ] = read_shd( filename );
	# Recommended to include a file extension, if it exists.
	# Otherwise it may find a different file than you intended.
	# Output is a 4-D pressure field p( Ntheta, Nsd, Nrd, Nrr )
	# mbp

	# if omitted, take a guess at the extension
	# Matlab 'exist' command is simpler; however, it searches the whole Matlab
	# search path

	# Determine type of file:
	Pos   = POS
	Pos.r = R
	Pos.s = S
	
	PlotType = [] # in case this was not sent
	
	if (filename == 'SHDFIL'):
		FileType = 'shd'
	elif (filename == 'SHDFIL.psh'):
		FileType = 'shdpsh'
	elif (filename == 'ASCFIL'):
		FileType = 'asc'
	elif (filename == 'GRNFIL'):
		FileType = 'grn'
	elif (filename == 'GRNFIL.psh'):
		FileType = 'grnpsh'
	else:
		endchar = len(filename)
		if (endchar >=4):
			FileType = filename[endchar-3:endchar].lower()
	
	if (FileType == 'shd'): # binary format
		[ PlotTitle, PlotType, freq, atten, Pos, p ] = read_shd_bin( filename )
	elif (FileType == 'shdpsh'): # greens function pyc file
		f = open(SHDFIL,'r')
		PlotTitle   = pickle.load(f)
		PlotType    = pickle.load(f)
		freq        = pickle.load(f)
		atten       = pickle.load(f)
		p           = pickle.load(f)
		Pos.r.depth = pickle.load(f)
		Pos.r.range = pickle.load(f)
		Pos.s.depth = pickle.load(f)
		Pos.Nrd     = pickle.load(f)
		Pos.Nsd     = pickle.load(f)
		Pos.Nrr     = pickle.load(f)
		f.close()
	elif (FileType == 'psh'): # python format
		f = open(filename,'r')
		PlotTitle   = pickle.load(f)
		PlotType    = pickle.load(f)
		freq        = pickle.load(f)
		atten       = pickle.load(f)
		p           = pickle.load(f)
		Pos.r.depth = pickle.load(f)
		Pos.r.range = pickle.load(f)
		Pos.s.depth = pickle.load(f)
		Pos.Nrd     = pickle.load(f)
		Pos.Nsd     = pickle.load(f)
		Pos.Nrr     = pickle.load(f)
		f.close()
		Pos.s.depth = Pos.s.depth[0]
	elif (FileType == 'asc'): #ascii format
		[ PlotTitle, PlotType, freq, atten, Pos, p ] = read_shd_asc( filename )
	elif (FileType == 'grn'): # binary format (Green's function file)
		[ PlotTitle, PlotType, freq, atten, Pos, p ] = read_shd_bin( filename )
	elif (FileType == 'grnpkl'): # Green's function python file
		f = open(GRNFIL,'r')
		PlotTitle   = pickle.load(f)
		PlotType    = pickle.load(f)
		freq        = pickle.load(f)
		atten       = pickle.load(f)
		p           = pickle.load(f)
		Pos.r.depth = pickle.load(f)
		Pos.r.range = pickle.load(f)
		Pos.s.depth = pickle.load(f)
		Pos.Nrd     = pickle.load(f)
		Pos.Nsd     = pickle.load(f)
		Pos.Nrr     = pickle.load(f)
		f.close()
	else:
		print('PLOTSHD eror: Unrecognized file extension')
		exit()
	
	return [ PlotTitle, PlotType, freq, atten, Pos, p ]	
	
def read_shd_bin(filename):
	
	#Read in TL surfaces from a binary Bellhop/Kraken .SHD file
	#without having to convert to ASCII first.
	#Out put is a 4-D pressure fiels p(Ntheta,Nsd,Nrd,Nrr)
	Pos   = POS
	Pos.r = R
	Pos.s = S
	try:
		fid = open(filename, 'rb')
	except IOError:
		print('No shade file named %s exists; you must run a model first' % (filename) )
		exit()
	temp = ar.array('i')
	temp.read(fid,1)
	recl = temp[0]
	
	temp = ar.array('c')
	temp.read(fid,80)
	title = temp.tostring()
	
	fid.seek(4*recl,0)# reposition to end of first record
	
	temp = ar.array('c')
	temp.read(fid,10)
	plottype = temp.tostring()
	
	temp = ar.array('f')
	temp.read(fid,1)
	xs = temp[0]
	
	temp = ar.array('f')
	temp.read(fid,1)
	ys = temp[0]
	
	fid.seek(2*4*recl,0) # reposition to end of second record
	
	temp = ar.array('f')
	temp.read(fid,1)
	freq = temp[0]
	
	temp = ar.array('i')
	temp.read(fid,1)
	Ntheta = temp[0]
	
	temp = ar.array('i')
	temp.read(fid,1)
	Nsd = temp[0]
	
	temp = ar.array('i')
	temp.read(fid,1)
	Nrd = temp[0]
	
	temp = ar.array('i')
	temp.read(fid,1)
	Nrr = temp[0]
	
	temp = ar.array('f')
	temp.read(fid,1)
	atten = temp[0]
	
	#reposition to end of record 3
	fid.seek(3*4*recl,0)
	
	temp = ar.array('f')
	temp.read(fid,Ntheta)
	Pos.theta = temp[0]
	
	#reposition to end of record 4
	fid.seek(4*4*recl,0)
	
	temp = ar.array('f')
	temp.read(fid,Nsd)
	Pos.s.depth = temp[0]
	
	#reposition to end of record 5
	fid.seek(5*4*recl,0)
	
	temp = ar.array('f')
	temp.read(fid,Nrd)
	Pos.r.depth = array(temp)
	
	#reposition to end of record 6
	fid.seek(6*4*recl,0)
	
	temp = ar.array('f')
	temp.read(fid,Nrr)
	Pos.r.range = array(temp)
	
	# Each record holds data from one source depth/receiver depth pair
	
	if (plottype == 'rectilin  '):
		pressure = zeros( (Ntheta, Nsd, Nrd, Nrr),complex )
		Nrcvrs_per_range = Nrd
	elif(plottype == 'irregular '):
		pressure = zeros( (Ntheta, Nsd, 1, Nrr),complex )
		Nrcvrs_per_range = 1
	else:
		pressure = zeros( (Ntheta, Nsd, Nrd, Nrr),complex )
		Nrcvrs_per_range = Nrd
	
	
	for itheta in range(Ntheta):
		for isd in range(Nsd):
			for ird in range(Nrcvrs_per_range):
				recnum = 7 + itheta*Nsd*Nrcvrs_per_range + isd*Nrcvrs_per_range + ird
				try:
					fid.seek(recnum*4*recl,0)
				except:
					print('Error: Seek to specified record failed in read_shd_bin')
					exit()
				temp1 = ar.array('f')
				temp1.read(fid,2*Nrr)
				temp = array(temp1) # Read complex data
				pressure[itheta,isd,ird,:] = temp[:2*Nrr:2] + 1.j*temp[1:2*Nrr:2]
				#Transmission loss matrix indexed by  sd x rd x rr
	fid.close()
	return [title,plottype, freq, atten, Pos, pressure]

	
def plotray(rayfil):
	
	# PLot the RAYfil produced by bellhop
	#usage: plotray(rayfil)
	# where rayfil is the ray file (without the extension)
	
	if((rayfil != 'RAYFIL') and (rayfil.__contains__('.ray')==False)):
		rayfil = rayfil + '.ray' #append extension
	
	#plots a BELLHOP ray file
	try:
		fid = open(rayfil,'r')
	except IOError:
		print('No ray file called %s exists; you must run BELLHOP first with ray output selected'%(rayfil))
		exit()
	
	# read header stuff
	
	#Exract letter between the quotes
	TITLE  = fid.readline()
	nchars = []
	nchars.append(TITLE.find("'")) # find first half quote
	nchars.append(TITLE.rfind("'")) # find last half quote
	TITLE  = TITLE[nchars[0] + 1 : nchars[1]]
	
	FREQ   = float(fid.readline().split()[0])
	NBEAMS = int(  fid.readline().split()[0])
	DEPTHT = float(fid.readline().split()[0])
	DEPTHB = float(fid.readline().split()[0])
	
	# read rays
	
	# plot with depth axis positive down
	
	plt.figure()
	
	#plt.ylim(6000.0, 0.0)
	plt.xlabel('Range (km)')
	plt.ylabel('Depth (m)')
	plt.title(TITLE)
	
	#axis limits
	rmin = +1e9
	rmax = -1e9
	zmin = +1e9
	zmax = -1e9
	
	for ibeam in range(NBEAMS):
		alpha0    = float(getLine(fid).split()[0])
		temp      = getLine(fid).split()
		nsteps    = int(  temp[0])
		NumTopBnc = float(temp[1])
		NumBotBnc = float(temp[2])
		if (nsteps):
			r = zeros(nsteps)
			z = zeros(nsteps)
			for i in range(nsteps):
				temp = getLine(fid).split()
				r[i] = float(temp[0])
				z[i] = float(temp[1])
			if ( (NumTopBnc > 1) and (NumBotBnc > 1) ):
				plt.plot(r/1000,z,'k') # hits both boundaries
			elif(NumBotBnc >=1):
				plt.plot(r/1000,z,'b') # hits bottom only
			elif(NumTopBnc >=1):
				plt.plot(r/1000,z,'k') # hits surface only
			else:
				plt.plot(r/1000,z,'r')
			# update axis limits
			temp = min(r)
			rmin = min(rmin,temp)
			temp = max(r)
			rmax = max(rmax,temp)
			temp = min(z)
			zmin = min(zmin,temp)
			temp = max(z)
			zmax = max(zmax,temp)
			if (zmin==zmax): # horizontal ray causes scaling problem
				zmax = zmin + 1
			plt.ylim(zmax,zmin)
			plt.xlim(rmin/1000,rmax/1000)
			
		else:
			break
	
	fid.close()




















