PROGRAM TOASC

  ! Converts shade file to ASCII format

  USE SdRdRMod

  INTEGER SHDFIL, ASCFIL
  PARAMETER ( ASCFIL = 26 )

  COMPLEX, ALLOCATABLE ::   P( : )
  CHARACTER Title*80, PlotType*10, FileName*80

  ! Read header

  SHDFIL = 25
  FileName = ' '
  CALL ReadHeader( SHDFIL, FileName, Title, Freq, Atten, DELTAR, PlotType, xs, ys )
  ALLOCATE( P( NR ) )

  ! Write header

  OPEN( FILE = 'ASCFIL', UNIT = ASCFIL, FORM = 'FORMATTED' )

  WRITE( ASCFIL, '( A80 )' ) TITLE
  WRITE( ASCFIL, * ) '''', PlotType, '''', XS, YS
  WRITE( ASCFIL, * ) FREQ, Ntheta, Nsd, Nrd, Nr, atten
  WRITE( ASCFIL, '( 6E13.5 )' ) Theta( 1 : Ntheta )
  WRITE( ASCFIL, '( 6E13.5 )' ) SD(    1 : Nsd    )
  WRITE( ASCFIL, '( 6E13.5 )' ) RD(    1 : Nrd    )
  WRITE( ASCFIL, '( 6E13.5 )' ) R(     1 : Nr     )

  ! Main loop: convert pressure surfaces for each s/r combo

  DO itheta = 1, Ntheta
     DO is = 1, Nsd
        IREC = 7 + ( itheta - 1 ) * Nsd * Nrd + ( is - 1 ) * Nrd

        DO IR = 1, NRD
           IREC = IREC + 1
           READ( SHDFIL, REC = IREC ) P
           WRITE( *, * ) itheta, is, ir, SD( is ), RD( ir )
           WRITE( ASCFIL, '( 6E13.5 )' ) P
        END DO

     END DO
  END DO

  CLOSE( ASCFIL )

  STOP
END PROGRAM TOASC
