PROGRAM TOBIN

  !     Converts ASCII format to binary format

  INTEGER SHDFIL, ASCFIL
  PARAMETER ( SHDFIL = 25, ASCFIL = 5 )

  REAL,    ALLOCATABLE :: R( : ), RD( : ), SD( : ), theta( : )
  COMPLEX, ALLOCATABLE :: P( : )
  CHARACTER TITLE*80, PLTTYP*10, FileName*6

  !     *** Read the header data ***

  READ( ASCFIL, '( A80 )' ) TITLE
  READ( ASCFIL, * ) PLTTYP, XS, YS
  READ( ASCFIL, * ) FREQ, Ntheta, NSD, NRD, NR, atten

  ALLOCATE( SD( NSD ), RD( NRD ), R( NR ), theta( Ntheta ), P( NR ) )

  READ( ASCFIL, '( 6E13.5 )' ) theta( 1 : Ntheta )
  READ( ASCFIL, '( 6E13.5 )' ) SD(    1 : NSD    )
  READ( ASCFIL, '( 6E13.5 )' ) RD(    1 : NRD    )
  READ( ASCFIL, '( 6E13.5 )' ) R(     1 : NR     )

  !     *** Write the header to the SHDFIL ***

  FileName = 'SHDFIL'
  CALL WriteHeader( FileName, TITLE, theta, Ntheta, SD, NSD, RD, NRD, R, NR, FREQ, ATTEN, PLTTYP, XS, YS )

  !     *** Main loop: convert pressure surfaces for each S/R combo ***

  DO itheta = 1, Ntheta
     DO ISD = 1, NSD
        IREC = 7 + ( itheta - 1 ) * Nsd * Nrd + ( ISD - 1 ) * NRD

        DO IRD = 1, NRD
           IREC = IREC + 1
           READ( ASCFIL, '( 6E13.5 )' ) ( P( J ), J = 1, NR )
           WRITE( *, * ) ISD, IRD, SD( ISD ), RD( IRD )
           WRITE( SHDFIL, REC = IREC ) ( P( J ), J = 1, NR )
        END DO

     END DO
  END DO

  STOP
END PROGRAM TOBIN
