SUBROUTINE ReadHeader( SHDFil, FileName, Title, Freq, Atten, DeltaR, PlotType, xs, ys )

  USE SdRdRMod

  INTEGER, PARAMETER :: PRTFil = 6
  INTEGER   SHDFil
  CHARACTER Title*80, FileName*80, PlotType*10

  ! Open file, read header
  IF ( SHDFil == 0 ) SHDFil = 25
  IF ( FileName(1:1) == ' ' ) FileName = 'SHDFIL'

  ! INQUIRE( FILE = FileName, RECL = IRECL )
  OPEN( UNIT = SHDFil,   FILE = FileName, STATUS = 'OLD', ACCESS = 'DIRECT', FORM = 'UNFORMATTED', RECL = 4, IOSTAT = IOStat )
  IF ( IOsTAT /= 0 ) CALL ERROUT( PRTFIL, 'F', 'RDHEAD', 'Unable to open shade file' )
  READ( SHDFil, REC = 1 ) LRecl
  CLOSE( UNIT = SHDFil )
  OPEN( UNIT = SHDFil,   FILE = FileName, STATUS = 'OLD', ACCESS = 'DIRECT', FORM = 'UNFORMATTED', RECL = 4 * LRecl )

  READ( SHDFil, REC = 1 ) LRecl, Title
  READ( SHDFil, REC = 2 ) PlotType, xs, ys
  READ( SHDFil, REC = 3 ) Freq, Ntheta, Nsd, Nrd, Nr

  xs = xs / 1000.0
  ys = ys / 1000.0

  ALLOCATE( SD( Nsd ), RD( Nrd ), R( Nr ), theta( Ntheta ), Stat = IAllocStat )
  IF ( IAllocStat /= 0 ) CALL ERROUT( PRTFIL, 'F', 'RDHEAD', 'Too many source/receiver combinations' )

  READ( SHDFil, REC = 4 ) theta
  READ( SHDFil, REC = 5 ) SD
  READ( SHDFil, REC = 6 ) RD
  READ( SHDFil, REC = 7 ) R

  DeltaR = R( NR ) - R( NR - 1 )

  RETURN
END SUBROUTINE ReadHeader
