% Parabolic Bottom test
% mbp

% *************************************************
% linear boundary interpolation

make_bdry( 'L' )

% the rays:
bellhop ParaBot
figure; plotray ParaBot

plotati 'ParaBot'   % superimpose an altimetry plot
plotbty 'ParaBot'   % superimpose a bathymetry plot

%print -depsc ParaBotL

% TL: Geometric ray theory
copyfile( 'ParaBot.bty', 'ParaBotTLGeom.bty' );
copyfile( 'ParaBot.ati', 'ParaBotTLGeom.ati' );
bellhop ParaBotTLGeom
plotshd( 'ParaBotTLGeom.shd', 2, 1, 1 )
caxis( [ 0 40 ] )

plotati 'ParaBot'   % superimpose an altimetry plot
plotbty 'ParaBot'   % superimpose a bathymetry plot

% TL: Gaussian beams
copyfile( 'ParaBot.bty', 'ParaBotTLGB.bty' );
copyfile( 'ParaBot.ati', 'ParaBotTLGB.ati' );
bellhop ParaBotTLGB
plotshd( 'ParaBotTLGB.shd', 2, 1, 2 )
caxis( [ 0 40 ] )

plotati 'ParaBot'   % superimpose an altimetry plot
plotbty 'ParaBot'   % superimpose a bathymetry plot

%print -dpng ParabotTL_L
%%

% *************************************************
% curvilinear boundary interpolation

make_bdry( 'C' )

% the rays:
bellhop ParaBot
figure; plotray ParaBot
plotati 'ParaBot'   % superimpose an altimetry plot
plotbty 'ParaBot'   % superimpose a bathymetry plot
%print -depsc ParaBotC

% TL: Geometric ray theory
copyfile( 'ParaBot.bty', 'ParaBotTLGeom.bty' );
copyfile( 'ParaBot.ati', 'ParaBotTLGeom.ati' );
bellhop ParaBotTLGeom
plotshd( 'ParaBotTLGeom.shd', 2, 1, 1 )
caxis( [ 0 40 ] )

plotati 'ParaBot'   % superimpose an altimetry plot
plotbty 'ParaBot'   % superimpose a bathymetry plot

% TL: Gaussian beams
copyfile( 'ParaBot.bty', 'ParaBotTLGB.bty' );
copyfile( 'ParaBot.ati', 'ParaBotTLGB.ati' );
bellhop ParaBotTLGB
plotshd( 'ParaBotTLGB.shd', 2, 1, 2 )
caxis( [ 0 40 ] )

plotati 'ParaBot'   % superimpose an altimetry plot
plotbty 'ParaBot'   % superimpose a bathymetry plot

%print -depsc ParaBotTLGB_C

% figure
% plotshd( 'ParaBotTLGB.shd' )
% caxis( [ 0 40 ] )
% 
% plotati 'ParaBot'   % superimpose an altimetry plot
% plotbty 'ParaBot'   % superimpose a bathymetry plot
% print -depsc ParaBotTLGB_C