import sys
sys.path.append('../../Python')
import bellhopf
import plot
import matplotlib.pyplot as plt
from scipy.special import *
from matplotlib import mpl

#**********PointLine*************************

bellhopf.bellhopF('LloydPointB')
plot.plotshd('LloydPointB.shd',5,2,1,[40,80])

bellhopf.bellhopF('LloydPoint_gbtB')
plot.plotshd('LloydPoint_gbtB.shd',5,2,2,[40,80])

bellhopf.bellhopF('LloydLineB')
plot.plotshd('LloydLineB.shd',5,2,5,[0,25])

bellhopf.bellhopF('LloydLine_gbtB')
plot.plotshd('LloydLine_gbtB.shd',5,2,6,[0,25])

# exact solution
freq = 5
k0 = 2*pi*freq/1500.0
zs = 3000
zr = linspace(0,5000,201)
rr = linspace(25,10000,401)
ppoint = zeros((201,401),complex)
pline  = zeros((201,401),complex)
for iz in range(201):
    rmat1 = (rr**2 + (zr[iz] - zs)**2)**(0.5)
    rmat2 = (rr**2 + (zr[iz] + zs)**2)**(0.5)
    ppoint[iz,:] = e**(complex(0,k0)*rmat1)*(1/rmat1) - e**(complex(0,k0)*rmat2)*(1/rmat2)
    pline[iz,:]  = hankel1(0,k0*rmat1) - hankel1(0,k0*rmat2)
pline = sqrt(pi/2)*pline
Z1 = -20.0*log10(abs(ppoint))
Z2 = -20.0*log10(abs(pline))

plt.subplot(5,2,9)
plt.ylim(float(max(zr))+1000.0, 0.0)
NORM = mpl.colors.Normalize(vmin=40,vmax=80)
plt.pcolor(rr,zr,Z1,norm=NORM,shading='interp')
plt.title('Exact point source solution')
plt.colorbar()

plt.subplot(5,2,10)
plt.ylim(float(max(zr))+1000.0, 0.0)
NORM = mpl.colors.Normalize(vmin=0,vmax=25)
plt.pcolor(rr,zr,Z2,norm=NORM,shading='interp')
plt.title('Exact line source solution')
plt.colorbar()

#if you want to run this runtests module without running 
#all of the tests cases uncomment 'plt.show()' below

#plt.show()